function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { NativeEventEmitter, NativeModules, Platform } from 'react-native';
const LINKING_ERROR = `The package 'react-native-android-quick-settings-tiles' doesn't seem to be linked. Make sure: \n\n` + Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n';
const {
  AndroidQuickSettingsTiles
} = NativeModules;
const quickSettings = AndroidQuickSettingsTiles ? AndroidQuickSettingsTiles : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }
});
const isAndroid = Platform.OS === 'android';
let eventEmitter;
if (isAndroid) {
  eventEmitter = new NativeEventEmitter(AndroidQuickSettingsTiles);
}
var resultType;
(function (resultType) {
  resultType["UNAVAILABLE"] = "UNAVAILABLE";
  resultType["GRANTED"] = "GRANTED";
})(resultType || (resultType = {}));
var stateChanged;
(function (stateChanged) {
  stateChanged["ACTITVE"] = "active";
  stateChanged["INACTIVE"] = "inactive";
})(stateChanged || (stateChanged = {}));
class RNQuickSettings {
  constructor() {
    _defineProperty(this, "_quickSettingsEventHandlers", void 0);
    _defineProperty(this, "request", option => {
      if (!isAndroid) return Promise.resolve(null);
      return quickSettings.request(option);
    });
    _defineProperty(this, "addEventListener", (type, handler) => {
      if (!isAndroid) return;
      let listener;
      if (type === 'onChange') {
        listener = eventEmitter.addListener("onChange", eventPayload => {
          handler(eventPayload);
        });
      } else {
        return;
      }
      this._quickSettingsEventHandlers.set(type, listener);
    });
    _defineProperty(this, "removeEventListener", type => {
      if (!isAndroid) return;
      const listener = this._quickSettingsEventHandlers.get(type);
      if (!listener) {
        return;
      }
      listener.remove();
      this._quickSettingsEventHandlers.delete(type);
    });
    _defineProperty(this, "getLastChanged", () => {
      if (!isAndroid) return Promise.resolve(null);
      return quickSettings.getLastChanged();
    });
    this._quickSettingsEventHandlers = new Map();
  }
}
export default new RNQuickSettings();
//# sourceMappingURL=index.js.map